#ifndef IO_Selector_h
#define IO_Selector_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class IO_Selector : public pfodControl {
  public:
    IO_Selector(bool _hasPWM, pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void setBase(int c, int r);
    void setBaseScaling(double _scaling);
    char getCmd_Input();
    char getCmd_InputPullup();
    char getCmd_Output();
    char getCmd_PWM();
    void setValue(int newValue);
    void forceFullUpdate();

  private:
    static const  char buttonCmd_Input = 'a';
    static const  char buttonCmd_InputPullup = 'b';
    static const  char buttonCmd_Output = 'c';
    static const  char buttonCmd_PWM = 'p';

    void fullUpdate();
    boolean haveStateChange();
    void saveCurrentState();
    int baseCol;
    int baseRow;
    float baseScaling;
    int z_idx;
    int previousValue; // for update
    boolean has_PWM;
    boolean forceUpdate;
};
#endif // IO_Selector_h





