#ifndef Nano_IO_Pin_h
#define Nano_IO_Pin_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class Nano_IO_Pin : public pfodControl {
  public:
    Nano_IO_Pin(char _cmd, int pinNo, pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void setBase(int c, int r);
    char getCmd();
    int getPinNo();
    int getMode();
    void setMode(byte m);
    int getPwmValue();
    void setPwmValue(int _pwmValue);
    void setValue(int newValue);
    void forceFullUpdate();
    void setSelected();
    void clearSelected();


    static const int DIGITAL_INPUT = 0;
    static const int DIGITAL_INPUT_PULLUP = 1;
    static const int DIGITAL_OUTPUT = 2;
    static const int DIGITAL_PWM = 3;

  private:
    char buttonCmd;
    void fullUpdate();
    boolean haveStateChange();
    void saveCurrentState();
    int baseCol;
    int baseRow;
    int z_idx;
    int pinNo;
    byte mode;
    byte previousMode; // for update
    int previousValue; // for update
    boolean forceUpdate;
    int pwmValue;// = 0;
    int previousPwmValue;// = 0; // for update
    boolean showSelected;// = false;
    boolean previousShowSelected;// = false;
};
#endif // Nano_IO_Pin_h





