#ifndef RedbearNanoV2_board_h
#define RedbearNanoV2_board_h
/*
   (c)2014-2017 Forward Computing and Control Pty. Ltd.
   NSW Australia, www.forward.com.au
   This code is not warranted to be fit for any purpose. You may only use it at your own risk.
   This code may be freely used for both private and commercial use
   Provide this copyright is maintained.
*/

#include <pfodControl.h>

class RedbearNanoV2_board : public pfodControl {
  public:
    RedbearNanoV2_board(pfodDwgs *_dwgsPtr);
    void draw();
    void update();
    void drawFirst();
    void drawLast();
    void setBase(int c, int r);
    void drawOutline();
    void drawPins();
    int getBaseCol();
    int getBaseRow();
    void setLed(byte off);
    byte getLed();
    void setLedCmd(byte c);
    void drawLedTxt();
    void drawLeftNames();
    void drawRightNames();
    void drawBottomNames();

    static const int colPadding = 11;
    static const int rowPadding = 2;
    static const int boardCols = 14; // 0.05 inchs
    static const int boardRows = 16;
    static const int cols_Nano = boardCols + colPadding + (colPadding / 3) + 1;
    static const int rows_Nano = boardRows + 2 * rowPadding;


  private:
    int baseCol;
    int baseRow;
    int z_idx;
    byte ledState;
    byte ledCmd;
    void drawPad(int offsetC);
    void drawPinHole(int offsetC);
    void drawLed();
    void updateLed();

};
#endif // RedbearNanoV2_board_h
